﻿namespace HeuristicLab.Algorithms.DataAnalysis.SymRegGrammarEnumeration {
  public class Grammar {

    public Symbol StartSymbol;

    public Grammar(string[] variables) {
      #region Define Symbols
      VariableSymbol var = new VariableSymbol("var", variables);

      NonterminalSymbol expr = new NonterminalSymbol("Expr");
      NonterminalSymbol term = new NonterminalSymbol("Expr");
      NonterminalSymbol factor = new NonterminalSymbol("Expr");

      TerminalSymbol addition = new TerminalSymbol("+");
      TerminalSymbol multiplication = new TerminalSymbol("*");
      #endregion


      #region Production ruless
      StartSymbol = expr;

      expr.AddProduction(term, expr, addition);
      expr.AddProduction(term);

      term.AddProduction(factor, term, multiplication);
      term.AddProduction(factor);

      factor.AddProduction(var);
      #endregion
    }
  }
}
